package com.malk.shanghaishiwei.server;

import cn.hutool.core.util.ObjectUtil;
import com.malk.Util.UtilHttp;
import com.malk.server.common.McException;
import com.malk.server.common.VenR;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Arrays;
import java.util.Map;

/**
 * 返回值配置参考McR
 */
@Data
@NoArgsConstructor
public class HTR extends VenR {

    private boolean isSuccess;

    private String errorCode;

    private String errorMessage;

    private String data;

    /**
     * 断言错误信息
     */
    @Override
    public void assertSuccess() {
        // prd 合同接口分为3次推送, 先推送合同, 再推送条款, 最后推送附件, 未避免其他报错导致合同重新推送报错因此过滤
        if (!Arrays.asList("合同编号不能重复", "该日期已存在相同的条款").contains(errorMessage)) {
            McException.assertException(ObjectUtil.isNotNull(errorCode) || !isSuccess, errorCode, errorMessage, "SHHT");
        }
    }

    /**
     * 通用post请求
     */
    public static HTR doPost(String url, Map header, Map param, Map body) {
        return (HTR) UtilHttp.doPost(url, header, param, body, HTR.class);
    }

    /**
     * 通用get请求
     */
    public static HTR doGet(String url, Map header, Map param) {
        return (HTR) UtilHttp.doGet(url, header, param, HTR.class);
    }
}

