package com.malk.xiding.controller;

import com.alibaba.fastjson.JSON;
import com.malk.Util.UtilMap;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDClient;
import com.malk.xiding.service.GSClient;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * 错误抛出与拦截详见CatchException
 */
@Slf4j
@RestController
@RequestMapping("/xiding-2")
public class GSController {

    @Autowired
    private GSClient gsClient;

    @PostMapping("month/report")
    McR report() {

        gsClient.collectMonthReport();
        return McR.success();
    }

    @PostMapping("month/exception")
    McR exception() {

        gsClient.exceptionMonthReport();
        return McR.success();
    }

    @PostMapping("month/validate")
    McR validate(@RequestBody Map data) {

        gsClient.validateManHour(UtilMap.getString(data, "userId"), ((Map) data.get("details")));
        return McR.success();
    }


    @Autowired
    private YDClient ydClient;

    @PostMapping("test")
    McR test() {

        // 不执行更新: 月度工时未全部确认
        long count = ydClient.queryData(YDParam.builder()
                .formUuid("FORM-TD966Z81I9ODTCY66GH345S03VW03JJF6EQLL5")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("textField_lm5n9tjp", "2023-11")))
                .instanceStatus("RUNNING")
                .build(), YDConf.FORM_QUERY.retrieve_search_process).getTotalCount();
        if (count != 0) {
            return null;
        }
        return McR.success(count);
    }
}
