package com.malk.xiding.controller;

import com.malk.Util.UtilDateTime;
import com.malk.server.common.McR;
import com.malk.server.fxiaoke.FXKConf;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Attendance;
import com.malk.service.dingtalk.DDClient_Contacts;
import com.malk.service.dingtalk.DDClient_Workflow;
import com.malk.service.fxiaoke.FXKClient;
import com.malk.xiding.repository.dao.XdDdApproveRecordDao2;
import com.malk.xiding.repository.dao.XdDdFxkRelationDao;
import com.malk.xiding.server.XDConf;
import com.malk.xiding.service.XDService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 错误抛出与拦截详见CatchException
 */
@Slf4j
@RestController
@RequestMapping("/xiding")
public class XDController {

    @Autowired
    private XDService xdService;

    @Autowired
    private DDClient_Attendance ddClient_attendance;

    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDClient_Contacts ddClient_contacts;

    @Autowired
    private XdDdApproveRecordDao2 approveRecordDao2;

    @Autowired
    private FXKClient fxkClient;

    @Autowired
    private FXKConf fxkConf;

    @Autowired
    private XdDdFxkRelationDao relationDao;

    @PostMapping("test3")
    McR test3(@RequestParam String name) {

        Date sTime = UtilDateTime.parseDateTime("2024-01-29" + " 00:00:00");
        Date eTime = UtilDateTime.parseDateTime("2024-02-02" + " 23:59:59");

        //List<Map> records = fxkClient.getAttendance_All(fxkClient.getAccessToken(), fxkConf.getCorpId(), sTime.getTime(), eTime.getTime(), Arrays.asList(relationDao.findByName(name).getIdFxxk()));
        List<Map> records = fxkClient.getAttendance_All(fxkClient.getAccessToken(), fxkConf.getCorpId(), sTime.getTime(), eTime.getTime(), Arrays.asList("FSUID_4B61D59E5E3BF3C631322184298E770B"));
        log.info("xxxx, {}", records.size());

        return McR.success(records);
    }

    @Autowired
    private DDClient_Workflow ddClient_workflow;

    @PostMapping("test1")
    McR test1() {

        log.info("###### [XD]同步审批单开始 ######");
        long endTime = new Date().getTime() - 0 * 24 * 60 * 60 * 1000L;
        long startTime = endTime - 45 * 24 * 60 * 60 * 1000L;
        xdService.syncApprove(startTime, endTime, XDConf.TMP_CODE_CC, "出差");
//        xdService.syncApprove(startTime, endTime, XDConf.TMP_CODE_WC, "外出");

        xdService.syncApprove(UtilDateTime.parseDate("2024-01-08").getTime(), UtilDateTime.parseDate("2024-01-10").getTime(), XDConf.TMP_CODE_WC, "外出");
        return McR.success();
    }

    @PostMapping("test2")
    McR test2() {
        for (int i = 8; i <= 13; i++) {
            Date sTime = UtilDateTime.parseDateTime("2024-03-" + i + " 00:00:00");
            Date eTime = UtilDateTime.parseDateTime("2024-03-" + i + " 23:59:59");
            xdService.syncAttendance(0, sTime, eTime);
            xdService.syncAttendanceForCC(0, sTime, eTime);

        }
        return McR.success();
    }

    @PostMapping("test5")
    McR test5() {
//        ddClient_attendance.uploadAttendanceRecord(ddClient.getAccessToken(), "01184453430538751536", "纷享销客同步", "纷享销客同步", null, 1689555600000L);
        return McR.success();
    }
}
