package com.malk.service.aliwork;

import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;

import java.util.List;
import java.util.Map;

public interface YDService {

    /**
     * 操作数据 [异步]
     */
    Object operateData(YDParam param, YDConf.FORM_OPERATION type);

    /**
     * 查询数据 [子表]
     */
    List<Map> queryDetails(YDParam ydParam);

    /**
     * 查询全部 [主表]
     */
    List<Map> queryAllFormData(YDParam YDParam, boolean isProcess);

    /**
     * 全表复制 [镜像] todo, 明细超过20条未处理, 组件替换和忽略未处理
     *
     * @param cParam 当前表数据, 实例ID
     * @param sParam 目标表数据, 表单ID/流程ID
     */
    Object copyFormData(YDParam cParam, YDParam sParam);

    /**
     * upsert方法 [todo: 优化 批量的数据兼容]
     *
     * @param lambda 查询数据回调, 传递查询结果list, 接收回调返回map传递钉到formData内, 若返回为空则不支持Upsert
     */
    Object upsertFormData(String formUuid, Map condition, Map formData, UpsertLambda lambda);

    /**
     * ppExt 函数式编程：Stream类、Lambda表达式和函数接口（Functional Inteface）
     * -
     * 自定义Lambda是为了更好的代码提示和数据类型定义: @FunctionalInterface，该接口为函数接口，一个函数接口只能存在一个方法
     * 特别注意，非异步情况下，和网络请求一致，回调默认同步等待【回调方式可自定义：如兼容并发可有，同步单次回调、同步累积回调、并发异步执行、并发累积回调】
     * 函数编程的最大好处，是可传入执行逻辑，而无需等待全部数据结果，尤其并发和异步情况下【异步效果优于Future】
     * -
     * 结合异步与并发, @Async说明和配置详见core/AsyncConfig
     */
    @FunctionalInterface
    interface UpsertLambda {
        Map dataList(List<Map> list);
    }
}
